const
  _SYMB    = 1;
  _NUMB    = 2;
  _IDENT   = 3;
  _STR     = 4;
  _REM     = 5;
var
  (***)
  tab      : array[0..100] of string[15];
  par      : array[0..2, 0..100] of string[15];
  (***)
  step     : integer;
  t        : integer;
  l,p      : integer;
  s        : string;
  ch       : char;
  eoff     : boolean;
  f        : text;
  name     : string;
  nln      : boolean;
  oldch    : char;
  procLev  : integer;
  className: string;
  typ      : integer;
  num      : longInt;
  nums     : string;
  _inUnit  : boolean;


function hex(b : byte) : string;
{ॢ   hex ப}
const
  h : array[0..15] of char = '0123456789abcdef';
begin
  hex:=h[b shr 4]+h[b and 15];
end;


function hexw(w : word) : string;
{ॢ ᫮  hex ப}
begin
  hexw:=hex(hi(w))+hex(lo(w));
end;


procedure out(s : string);
{뢮 ப, ᫨ ᨬ #13 -   ப   }
var
  i,j,len : integer;
begin
  len:=length(s);
  for i:=1 to len do
  begin
    if s[i]<>#13 then
    begin
      if nln=true then
      begin
        writeln;
        for j:=1 to step do write(' ');
        nln:=false;
      end;
      write(s[i]);
    end
    else nln:=true;
  end;
  oldch:=s[len];
end;


procedure error(msg : string);
{饭  訡}
var
  s : string;
begin
  str(p,s);
  msg:=s+'): "'+msg+'"';
  str(l,s);
  out(#13' '#13'ERROR (str:'+s+' pos:'+msg);
  halt;
end;


(***)
procedure addtable(s : string; n : integer; p : string);
{ /  ࠬ   ⠡ ६}
var
  i : integer;
begin
  i:=100;
  tab[0]:=s;
  while (tab[i]<>s) do dec(i);
  if i=0 then
  begin
    i:=100;
    tab[0]:='';
    while (tab[i]<>'') do dec(i);
    tab[i]:=s;
  end;
  par[n,i]:=p;
end;
(***)


procedure getch;
{ ᨬ  室 䠩}
begin
  ch := #255;
  if eoff=false then
  begin
    read(f,ch);
    if ch=#10 then
    begin
      l:=l+1;
      p:=0;
      if l=267
      then p:=0;{<debug point}
    end;
    p:=p+1;
    eoff:=eof(f);
  end;
end;

{-----}

procedure getNum;
{ }
var
  s : string;
begin
  num:=0;
  nums:='';
  repeat
    nums:=nums+ch;
    num:=num*10+ord(ch)-ord('0');
    getch;
  until not (ch in ['0'..'9']);
end;


procedure getHexNum;
{ hex }
begin
  num:=0;
  nums:='0';
  ch:='x';
  repeat
    if ch in ['A'..'F'] then  inc(ch, (97-65));  {<- loChar}
    if ch in ['0'..'9'] then  num:=num*16+ord(ch)-ord(0)
    else if ch in ['a'..'f'] then num:=num*16+10+ord(ch)-ord('a');
    nums:=nums+ch;
    getch;
  until not (ch in ['0'..'9','A'..'F','a'..'f']);
end;


procedure tok;
{ ⮪  室 䠩}
begin
  repeat
    typ:=_SYMB;
    s := '';
    while (ch <= #32) do  getch;
    case ch of
     'A'..'Z',
     'a'..'z',
     '_'      : begin
                  repeat
                    if ch in [#65..#90] then inc(ch, (97-65));
                    s := s+ch;
                    getch;
                  until not (ch in ['0'..'9','_','A'..'Z','a'..'z']);
                  typ:=_IDENT;
                  if s='writeln' then s:='println'
                  else if s='write' then s:='print';
                  {...}
                end;
     '0'..'9' : begin
                  getNum;
                  s:=s+nums;
                  typ:=_NUMB;
                end;
     '$'      : begin
                  getHexNum;
                  s:=s+nums;
                  typ:=_NUMB;
                end;
     '''','#' : begin
                  s:=s+'"';
                  repeat
                    if ch='#' then
                    begin
                      getch;
                      if ch <> '$' then getNum else getHexNum;
                      s:=s+'\u'+hexw(num);
                    end
                    else
                    begin
                      repeat
                        getch;
                        while ch<>'''' do
                        begin
                          if ch='\' then s:=s+'\\'
                          else if ch='"' then s:=s+'\"'
                          else s:=s+ch;
                          getch;
                        end;
                        getch;
                        if ch<>'''' then break;
                        s:=s+'\''';
                      until false;
                    end;
                  until not (ch in ['''','#']);
                  s:=s+'"';
                  typ:=_STR;
                end;
     ':'      : begin
                  s := ch;
                  getch;
                  if ch = '=' then
                  begin
                    s := s+ch;
                    getch;
                  end;
                end;
     '>'      : begin
                  s := ch;
                  getch;
                  if ch = '=' then
                  begin
                    s := s+ch;
                    getch;
                  end;
                end;
     '<'      : begin
                  s := ch;
                  getch;
                  if (ch = '=') or (ch = '>') then
                  begin
                    s := s+ch;
                    getch;
                  end;
                end;
     '.'      : begin
                  s := ch;
                  getch;
                  if (ch = '.') or (ch = ')') then
                  begin
                    s := s+ch;
                    getch;
                  end;
                end;
     '('      : begin
                  s := ch;
                  getch;
                  if (ch = '.') then
                  begin
                    s := s+ch;
                    getch;
                  end
                  else if (ch = '*') then
                  begin
                    repeat
                      while ch <> '*' do
                      begin
                        s := s+ch;
                        getch;
                        if ch = #13 then
                        begin
                          s:=s+#13#10;
                          getch;
                          getch;
                        end;
                      end;
                      s := s+ch;
                      getch;
                    until ch = ')';
                    s := s+ch;
                    getch;
                    typ:=_REM;
                    out(#13'/*');
                    out(s);
                    out('*/'#13);
                  end;
                end;
     '/'      : begin
                  s := ch;
                  getch;
                  if ch='/' then
                  begin
                    repeat s:=s+ch; getch; until (ch=#13);
                    typ:=_REM;
                    out(#13'/*');
                    out(s);
                    out('*/'#13);
                  end;
                end;
     '{'      : begin
                  repeat
                    s := s+ch;
                    getch;
                    if ch = #13 then
                    begin
                      s := s+#13#10;
                      getch;
                      getch;
                    end;
                  until ch = '}';
                  s := s+ch;
                  getch;
                  typ:=_REM;
                  out(#13'/*');
                  out(s);
                  out('*/'#13);
                end;
     else       begin
                  s := ch;
                  getch;
                end;
    end;
  until typ<>_REM;
end;


procedure check(st : string);
{஢ ⮪}
begin
  if s<>st then error(st);
end;


procedure skip(st : string);
{ய ⮪}
begin
  check(st);
  tok;
end;


function expr(s1,s2 : string) : string;
{뢠 ⮪    ⮪: s1,s2  ";"}
var
  st : string;
  i1,i2 : integer;
begin
  i1:=0;
  i2:=0;
  st:='';
  repeat
    if s='and'      then s:='&&'
    else if s='div' then s:='/'
    else if s='mod' then s:='%'
    else if s='not' then s:='!'
    else if s='nil' then s:='null'
    else if s='or'  then s:='||'
    else if s='shl' then s:='<<'
    else if s='shr' then s:='>>'
    else if s='xor' then s:='^'
    else if s='='   then s:='=='
    else if s='<>'  then s:='!='
    else if s='('   then inc(i1)
    else if s=')'   then dec(i1)
    else if s='['   then inc(i2)
    else if s=']'   then dec(i2);
    if st[length(st)] in ['a'..'z','0'..'9'] then if s[1] in ['a'..'z','0'..'9'] then st:=st+' ';
    st:=st+s;
    tok;
  until ((s=s1) or (s=s2) or (s=';') or (s='end')) and (i1<=0) and (i2<=0);
  expr:=st;
end;


function vartyp : string;
{  ६}
var
  name : array[0..63] of string[15];
  s1,s2,s3 : string;
  i,n : integer;
begin
  n:=0;
  s1:='';
  repeat
    s1:=s1+s;
    name[n]:=s;
    n:=n+1;
    tok;
    if s<>',' then break;
    s1:=s1+', ';
    tok;
  until false;
  if s=';' then
  begin
    vartyp:=s1;
    exit;
  end;
  if (s=':') then tok;
  if (s='^') then tok;
  {====}
  if s='array' then
  begin
    tok;
    s3:='';
    check('[');
    repeat
      tok;
      s2:=expr('..',']');
      skip('..');
      {for i:=0 to n-1 do  addtable(name[i],0,s2);}
      s3:=s3+'['+expr(',',']')+'+1-'+s2+']';
      for i:=0 to n-1 do  name[i]:=name[i]+'[]';
    until s<>',';
    skip(']');
    check('of');
    s1:='';
    s:='';
    i:=procLev;
    procLev:=1;
    s2:=vartyp;
    procLev:=i;
    for i:=0 to n-1 do
    begin
      if i>0 then if procLev=0 then s1:=s1+'public static ';
      s1:=s1+s2+' '+name[i]+'=new '+s2+s3;
      if i<n-1 then s1:=s1+';'#13;
    end;
    vartyp:=s1;
  end
  else if s='record' then
  begin
    tok;
    s3:='';
    repeat
      i:=procLev;
      procLev:=1;
      s3:=s3+vartyp;
      procLev:=i;
      if s<>';' then break;
      tok;
      if s='end' then break;
      s3:=s3+';'#13;
    until false;
    skip('end');
    vartyp:=s3;
  end
  else if s='string' then
  begin
    tok;
    if s='[' then
    begin
      repeat tok until s=']';
      tok;
    end;
    if procLev<>1 then
    begin
      s1:='';
      for i:=0 to n-1 do
      begin
        if i>0 then if procLev=0 then s1:=s1+'public static ';
        s1:=s1+'String '+name[i]+'=new String()';
        if i<n-1 then s1:=s1+';'#13;
      end;
      vartyp:=s1;
    end
    else vartyp:='String '+s1;
  end
  else if (s='integer') or (s='word') or (s='longint') then
  begin
    vartyp:='int '+s1;
    tok;
  end
  else if (s='byte') then
  begin
    vartyp:='byte '+s1;
    tok;
  end
  else if (s='real') or (s='single') or (s='double') then
  begin
    vartyp:='float '+s1;
    tok;
  end
  else if s='char' then
  begin
    vartyp:='char '+s1;
    tok;
  end
  else if s='boolean' then
  begin
    vartyp:='boolean '+s1;
    tok;
  end
  else if s='(' then
  begin
    s3:='';
    while s<>';' do
    begin
      s3:=s3+s;
      tok;
    end;
    vartyp:=s3;
  end
  else
  begin
    if procLev<>1 then
    begin
      s1:='';
      for i:=0 to n-1 do
      begin
        if i>0 then if procLev=0 then s1:=s1+'public static ';
        s1:=s1+s+' '+name[i]+'=new '+s+'()';
        if i<n-1 then s1:=s1+';'#13;
      end;
      vartyp:=s1;
    end
    else vartyp:=s+' '+s1;
    tok;
  end
end;


function getname : string;
{  ६}
var
  s1 : string;
begin
  s1:='';
  repeat
    s1:=s1+s;
    tok;
    while s='[' do {array-index}
    begin
      s1:=s1+'[';
      repeat
        tok;
        s1:=s1+expr(',',']');
        if s=',' then s1:=s1+', ';
      until s<>',';
      skip(']');
      s1:=s1+']';
    end;
    if s<>'.' then break;
    s1:=s1+s;
    tok;
  until false;
  getname:=s1;
  if s1='halt'
  then s1:='halt';
end;


procedure pars;
{ࠡ⪠ 権 몠}
var
  s1 : string[15];
  i  : integer;
begin
  if s='begin' then
  begin
    if procLev<2 then out('{'#13);
    procLev:=0;
    step:=step+2;
    repeat
      tok;
      if s<>'end' then pars;
    until s<>';';
    skip('end');
    step:=step-2;
    out('}'#13);
  end
  else if s='if' then
  begin
    tok;
    out('if ('+expr('then',';')+') ');
    skip('then');
    pars;
    {if s=';' then tok; {<- for facking MidletPascal}
    if s='else' then
    begin
      tok;
      step:=step+2;
      out('else ');
      pars;
      step:=step-2;
    end;
  end
  else if s='while' then
  begin
    tok;
    out('while ('+expr('do',';')+') ');
    skip('do');
    pars;
  end
  else if s='repeat' then
  begin
    out('do {'#13);
    step:=step+2;
    repeat
      tok;
      if s<>'until' then pars;
    until s<>';';
    step:=step-2;
    skip('until');
    out(#13'} while (!('+expr(';',';')+'));'#13);
  end
  else if s='for' then
  begin
    tok;
    s1:=expr(':=',';');
    skip(':=');
    out('for ('+s1+'='+expr('to','downto')+'; ');
    if s='to' then
    begin
      tok;
      out(s1+'<='+expr('do',';')+'; '+s1+'++) ');
    end
    else if s='downto' then
    begin
      tok;
      out(s1+'>='+expr('do',';')+'; '+s1+'--) ');
    end
    else error('to / downto');
    skip('do');
    pars;
  end
  else if s='case' then
  begin
    tok;
    out('switch ('+expr('of',';')+') {'#13);
    step:=step+2;
    repeat
      tok;
      if s='else' then
      begin
        tok;
        out('default: ');
        pars;
        skip(';');
      end;
      if s='end' then break;
      repeat
        out(#13'case '+expr(',',':'));
        if s<>',' then break;
        out(':'#13);
        tok;
      until false;
      skip(':');
      out(': ');
      pars;
      out('break;'#13);
    until s<>';';
    skip('end');
    step:=step-2;
    out('}'#13);
  end
  else if s='exit' then
  begin
    out('return'#13);
    tok;
  end
  else if (s[1] in ['_','a'..'z']) then
  begin
    s1:=getname;
    out(s1);
    if s=':=' then
    begin
      tok;
      out('='+expr('else', 'until')+';'#13);
    end
    else if s='(' then
    begin
      tok;
      out('(');
      repeat
        out(expr(')', ';'));
      until (s<>',');
      skip(')');
      out(')');
      if s=':=' then
      begin
        tok;
        out('='+expr('else', 'until')+';'#13);
      end
      else if (s=';') or (s='else') or (s='until') then out(';'#13);
    end
    else if (s=';') or (s='end') or (s='else') or (s='until') then
    begin
      if (s1<>'break') and (s1<>'halt') then out('()');
      out(';'#13);
    end
    else error(s);
  end;
end;


procedure vartab;
{ࠡ⪠ }
var
  s1 : string;
begin
  step:=step+2;
  repeat
    if s='var' then
    begin
      tok;
      repeat
        if procLev=0 then out('public static ');
        out(vartyp+';'#13);
        skip(';');
      until (s='var') or (s='const') or (s='type') or (s='begin') or (s='procedure') or (s='function');
    end
    else if s='const' then
    begin
      tok;
      repeat
        s1:=s;
        tok;
        if s=':' then
        begin
          s:=s1;
          s1:=vartyp;
          skip('=');
        end
        else
        begin
          skip('=');
          if typ=_NUMB then s1:='int '+s1
          else if typ=_STR then s1:='String '+s1;
          if procLev=0 then s1:='public static '+s1;
        end;
        out(s1+'='+expr(';',';')+';'#13);
        skip(';');
      until (s='var') or (s='const') or (s='type') or (s='begin') or (s='procedure') or (s='function');
    end
    else if s='type' then
    begin
      tok;
      repeat
        out(s+'=');
        tok;
        check('=');
        s:='';
        out('class {'#13);
        step:=step+2;
        out(vartyp+';'#13);
        step:=step-2;
        out('}'#13);
        skip(';');
      until (s='var') or (s='const') or (s='type') or (s='begin') or (s='procedure') or (s='function');
    end
    else if (s='procedure') or (s='function') then
    begin
      procLev:=1;
      tok;
      out(#13' '#13'public static ');
      name:=s+'(';
      tok;
      if s='(' then
      begin
        repeat
          tok;
          if s='var' then tok;
          name:=name+vartyp;
          if s<>';' then break;
          name:=name+'; ';
        until false;
        skip(')');
      end;
      if s=':' then
      begin
        tok;
        name:=s+' '+name;
        tok;
      end
        else name:='void '+name;
      out(name+') {'#13);
      skip(';');
      if _inUnit=false then
      begin
        procLev:=2;
        vartab;
        pars;
        skip(';');
      end;
      procLev:=0;
    end
    else break;
  until false;
  step:=step-2;
end;


begin
  assign(f, paramstr(1));
  reset(f);
  l:=1;
  p:=0;
  ch:=#0;
  step:=0;
  nln:=false;
  procLev:=0;
  out('//pascal to java converter'#13'//by arT(c).  IronWoodcutter@bk.ru'#13);
  tok;
  if (s='program') then
  begin
    tok;
    step:=0;
    className:=expr(';',';');
    out('class '+className+' {'#13);
    skip(';');
  end
  else if (s='unit') then
  begin
    tok;
    step:=0;
    className:=expr(';',';');
    out('class '+className+' {'#13);
    skip(';');
    _inUnit:=true;
    while s<>'interface' do tok;
    tok;
    if s='uses' then
    begin
      step:=2;
      repeat
        tok;
        out('import '+expr(';',';')+';'#13);
      until s<>',';
      skip(';');
    end;
    repeat
      vartab;
    until s='implementation';
    tok;
  end
  else
  begin
    step:=0;
    className:='pascal';
    out('class '+className+' {'#13);
  end;
  _inUnit:=false;
  {}
  if s='uses' then
  begin
    step:=2;
    repeat
      tok;
      out('import '+expr(';',';')+';'#13);
    until s<>',';
    skip(';');
  end;
  {}
  step:=0;
  vartab;
  check('begin');
  {}
  step:=step+2;
  out(#13' '#13''+className+'() {  //main proc'#13);
  procLev:=0;
  pars;
  step:=0;
  skip('.');
  out(#13'}');
  close(f);
end.
